.nolist
include \masm32\include\masm32rt.inc

COMMENT @ RichMasm options
OPT_Linker	link	; put polink if you prefer
OPT_DebugL	/FILEALIGN:512 /MERGE:.rdata=.text /MERGE:.data=.text /MERGE:.bss=.text /SECTION:.text,RWE ; /MERGE:.rsrc=.text  ; error can't merge

@
WinMain	PROTO:DWORD,:DWORD,:DWORD,:DWORD

sm	equ invoke SendMessage, ; for faster typing ;-)
IdMenuNew	equ 1000	; ID menu item New
IdMenuSave	equ 1001	; ID menu item Save
IdMenuCopy	equ 1100
IdEdit	equ 2000
IdButton1	equ 2001
IdButton2	equ 2002
IdStatic	equ 2003
IdEscape	equ VK_ESCAPE
AppX	equ 200
AppY	equ 200
AppWidth	equ 300
AppHeight	equ 200
ButtonWidth	equ 72
ButtonHeight	equ 24

.data
ClassAppWin	db "MyClass", 0
ClassButton	db "button", 0
ClassEdit	db "edit", 0
ClassStatic	db "static", 0
txButton1	db "PushMe", 0
txButton2	db "Say Hi", 0
txStatic	db "Press Escape to quit", 13, 10	; no 0 - text continues with AppName ;-)
AppName	db "Tiny Win App", 0
MyAccels	ACCEL <FCONTROL or FVIRTKEY, VK_S, IdMenuSave>
LastAccel	ACCEL <FVIRTKEY, VK_ESCAPE, IdEscape>

.data?
ClvEsp	dd ?
hInstance	HINSTANCE ?
CommandLine	LPSTR ?
hButton1	HWND ?
hButton2	HWND ?
hStatic	HWND ?
hEdit	HWND ?
hMenu	HWND ?
hM1	HWND ?
hM2	HWND ?
hButFnt	HWND ?
hAccT	HWND ?
buffer	db 512 dup(?)

.code
start:
	invoke GetModuleHandle, NULL
	mov hInstance, eax
	invoke GetCommandLine
	invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess, eax

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND
	call ClearLocVars	; set all local variables to zero
	mov wc.cbSize, SIZEOF WNDCLASSEX
	mov wc.style, CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc, offset WndProc
;	 mov wc.cbClsExtra, NULL
;	 mov wc.cbWndExtra, NULL
	push hInst
	pop wc.hInstance
	mov wc.hbrBackground, COLOR_BTNFACE+1
	mov wc.lpszClassName, offset ClassAppWin
	invoke LoadIcon, hInst, IDI_APPLICATION
	mov wc.hIcon, eax
	mov wc.hIconSm, eax
	invoke LoadCursor, NULL, IDC_ARROW
	mov wc.hCursor, eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx, WS_EX_CLIENTEDGE,
		addr ClassAppWin, addr AppName,
		WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,
		AppX, AppY, AppWidth, AppHeight,
		NULL, NULL, hInst, NULL
	mov hwnd, eax
	invoke ShowWindow, hwnd, SW_SHOWNORMAL
;	 invoke UpdateWindow, hwnd
	.Repeat
		invoke GetMessage, addr msg, NULL, 0, 0
		.break .if eax==0
		invoke TranslateAccelerator, hwnd, hAccT, addr msg
		.if eax==0	; not an accelerator
			invoke TranslateMessage, addr msg
			invoke DispatchMessage, addr msg
		.endif
	.Until 0
	mov eax, msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL rc:RECT
	SWITCH uMsg
	CASE WM_DESTROY
		invoke PostQuitMessage, NULL

	CASE WM_CREATE
		; -------------------- create keyboard shortcuts -------------------- 

		mov eax, 1+(dword ptr LastAccel-dword ptr MyAccels)/(SIZEOF ACCEL)
		invoke CreateAcceleratorTable, addr MyAccels, eax	; eax needed because of a [url=http://www.masm32.com/board/index.php?topic=10435.msg76444#msg76444]MASM Version 9.0 bug[/url]

		mov hAccT, eax
		; -------------------- create menus and sub-menus -------------------- 
		mov hMenu, rv(CreateMenu)				; create the main menu
		mov hM1, rv(CreateMenu)				; plus two
		mov hM2, rv(CreateMenu)				; sub menus
		invoke AppendMenu,hMenu, MF_POPUP, hM1,chr$("&File")
		invoke AppendMenu, hM1, MF_STRING, IdMenuNew, chr$("&New",9,"Ctrl+N")
		invoke AppendMenu, hM1, MF_STRING, IdMenuSave, chr$("&Save",9,"Ctrl+S")
		invoke AppendMenu,hMenu, MF_POPUP, hM2,chr$("&Edit")
		invoke AppendMenu, hM2, MF_STRING, IdMenuCopy, chr$("&Copy",9,"Ctrl+C")
		invoke SetMenu, hWnd, hMenu			; attach menu to main window
		; -------------------- create controls: buttons, edit window, static ---------- 
		invoke GetStockObject, ANSI_VAR_FONT	; get a cute little font for the controls
		mov hButFnt, eax
		invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr ClassEdit, NULL, 
			WS_CHILD or WS_VISIBLE or WS_BORDER\
			or ES_LEFT or ES_AUTOHSCROLL or ES_MULTILINE, 0, 0, 0, 0,
			hWnd, IdEdit, hInstance, NULL
		mov hEdit, eax							; we have created an edit window
;		sm eax, WM_SETFONT, hButFnt, 1	; you may choose the small font here
		invoke SetFocus, hEdit					; give the focus to the edit window
		invoke CreateWindowEx, NULL, addr ClassButton, addr txButton1, 
			WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON, 0, 0, 0, 0,
			hWnd, IdButton1, hInstance, NULL
		mov hButton1, eax						; upper button created
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font
		invoke CreateWindowEx, NULL, addr ClassButton, addr txButton2, 
			WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON, 0, 0, 0, 0,
			hWnd, IdButton2, hInstance, NULL
		mov hButton2, eax						; lower button created
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font
		mov edx, rc.bottom 					; area below the two buttons
		sub edx, ButtonHeight*2+15				; will be used for a static control
		invoke CreateWindowEx, NULL, addr ClassStatic, addr txStatic,
			WS_CHILD or WS_VISIBLE or ES_LEFT, 0, 0, 0, 0,
			hWnd, IdStatic, hInstance, NULL
		mov hStatic, eax						; static window under buttons created
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font

	CASE WM_COMMAND					; react here to menus and controls
		movzx eax, word ptr wParam			; the Ids are in the lowword of wParam
		switch eax
		case IdMenuNew						; feel free to call your own stuff here...
			sm hStatic, WM_SETTEXT, 0, chr$("You clicked New")
		case IdMenuSave
			sm hStatic, WM_SETTEXT, 0,
			chr$("You either clicked Save, or you pressed Control S")
		case IdMenuCopy
			sm hStatic, WM_SETTEXT, 0, chr$("You clicked Copy")
		case IdButton1
			call MyProc		; [url=+0]click here[/url] to jump to this procedure
		case IdButton2
			sm hEdit, WM_SETTEXT, 0, addr txStatic
		case IdEdit
			sm hStatic, WM_SETTEXT, 0, chr$("Type some text")
		case IdEscape
;			MsgBox 0, chr$("Sure to exit?"), addr AppName, MB_YESNO
;			.if eax==IDYES
				sm hWnd, WM_CLOSE, 0, 0	; Escape: exit without asking!
;			.endif
		default
			; MsgBox 0, chr$("Other control"), addr AppName, MB_OK
		endsw

	CASE WM_SIZE			; resize controls
		invoke GetClientRect, hWnd, addr rc
		push esi
		push ebx
		mov esi, rc.right
		sub esi, ButtonWidth	; editbox = window width minus button width
		mov ebx, rc.bottom
		sub ebx, 6
		invoke MoveWindow, hEdit, 3, 3, esi, ebx, 1
		add esi, 5				; buttons 5 pixels right of editbox
		mov ebx, rc.right
		sub ebx, esi
		sub ebx, 3
		invoke MoveWindow, hButton1, esi, 5, ebx, ButtonHeight, 1
		invoke MoveWindow, hButton2, esi, 8+ButtonHeight, ebx, ButtonHeight, 1
		mov edx, rc.bottom
		sub edx, ButtonHeight*2+15
		invoke MoveWindow, hStatic, esi, 11+ButtonHeight*2, ebx, edx, 1
		pop ebx
		pop esi

	DEFAULT
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
	ENDSW
	xor eax, eax
	ret
WndProc endp

MyProc proc
	MsgBox 0, chr$("Thank you so much for pushing me!"), addr AppName, MB_OK
	ret
MyProc endp		; [url=+1]back to wm_command[/url]

; Warning: ClearLocVars does not work with the proc uses edi syntax!
; Workaround: push/pop these registers manually after CLV
ClearLocVars proc		; first instruction after LOCALS - eax will be zero on exit
	pop ClvEsp		; save the return address to this global variable - 
					; now the stack is identical to the calling procedure
	xchg eax, ecx	; save ecx
	mov ecx, ebp	; base page of calling procedure
	sub ecx, esp	; ebp - esp = No. of bytes in locals
	mov esp, ebp	; discard existing locals
	shr ecx, 2		; divide by four
@@:	push 0			; dwords on stack
	loop @B		; until ecx=0
	xchg eax, ecx	; restore ecx, the 0 goes to eax
	push ClvEsp	; restore the return address
	ret
ClearLocVars endp

end start
OPT_Tmp2Asm	1
